﻿using System;
using System.Windows.Forms;
using NorthwindEntities;
using System.Linq;

namespace ConsultaEntidades
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            using (var contexto = new NorthwindEntities.NorthwindEntities())
            {
                //obtem os pedidos da entidade
                var pedidos = from p in contexto.Orders select p;
                //define o que será exibida na combo e valor de seleção e preenche o combobox
                cboPedidos.DisplayMember = "CustomerID";
                cboPedidos.ValueMember = "OrderID";
                cboPedidos.DataSource = pedidos.ToList();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            using (var contexto = new NorthwindEntities.NorthwindEntities())
            {
                // obtem o número do pedido selecionado na combobox
                int orderid = Convert.ToInt32(cboPedidos.SelectedValue);
                // obtem os itens de pedidos com numero de pedido igual a selecionado na combobox
                var listaPedidos = (from p in contexto.Orders.Include("Order_Details") where p.OrderID == orderid select p).ToList();
                //exibe o 
                // obtem os itens de pedidos com numero de pedido igual a selecionado na combobox
                var primeiroPedido = (from p in contexto.Orders.Include("Order_Details") where p.OrderID == orderid select p).First();
                dgvDetalhes.DataSource = listaPedidos;

                lstDetalhes.Items.Add(primeiroPedido.OrderID);
                lstDetalhes.Items.Add(primeiroPedido.CustomerID);
                lstDetalhes.Items.Add(primeiroPedido.EmployeeID);
                lstDetalhes.Items.Add(primeiroPedido.OrderDate);
                lstDetalhes.Items.Add(primeiroPedido.RequiredDate);
                lstDetalhes.Items.Add(primeiroPedido.ShippedDate);
                lstDetalhes.Items.Add(primeiroPedido.ShipVia);
                lstDetalhes.Items.Add(primeiroPedido.Freight);
                lstDetalhes.Items.Add(primeiroPedido.ShipName);
                lstDetalhes.Items.Add(primeiroPedido.ShipAddress);
                lstDetalhes.Items.Add(primeiroPedido.ShipCity);
                lstDetalhes.Items.Add(primeiroPedido.ShipRegion == null ? "" : primeiroPedido.ShipRegion);
                lstDetalhes.Items.Add(primeiroPedido.ShipPostalCode);
                lstDetalhes.Items.Add(primeiroPedido.ShipCountry);
            }
        }
        private void button3_Click(object sender, EventArgs e)
        {
            using (var contexto = new NorthwindEntities.NorthwindEntities())
            {
                contexto.ContextOptions.LazyLoadingEnabled = false;

                string codigo = cboPedidos.Text.Trim();
                lblCliente.Text = codigo;    
                var cliente = (from c in contexto.Customers where c.CustomerID == codigo select c).First();
                
                // Carrega os pedidos para o cliente selecionado
                if (!cliente.Orders.IsLoaded)
                {
                    cliente.Orders.Load();
                }

                foreach (Order pedido in cliente.Orders)
                {
                    // Carrega os itens para o pedido se não tiver ja carregado
                    if (!pedido.Order_Details.IsLoaded)
                    {
                        pedido.Order_Details.Load();
                    }
                    lstDetalhes1.Items.Add(String.Format("No. Pedido : {0}", pedido.OrderID));
                    lstDetalhes1.Items.Add(String.Format("Data Pedido: {0}", pedido.OrderDate.ToString()));

                foreach (Order_Detail item in pedido.Order_Details)
                {
                    //exibe os detalhes dos pedidos na listbox
                    lstDetalhes1.Items.Add(String.Format("Produto: {0} "
                        + "Qtde: {1}", item.ProductID.ToString(),item.Quantity.ToString()));
                }
              }
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            using (var contexto = new NorthwindEntities.NorthwindEntities())
            {
                // obtem o número do pedido selecionado na combobox
                int orderid = Convert.ToInt32(cboPedidos.SelectedValue);
                // obtem os itens de um pedido para o pedido selecionado
                var itenspedidos = (from p in contexto.Order_Details where p.OrderID == orderid select p).ToList();
                gdvDetalhes2.DataSource = itenspedidos;
            }

        }
    }
}
